<?php
/**
 * @file
 * Admin forms for system_status
 */

/**
 * Page callback: System settings settings.
 *
 * @see system_status_menu()
 */
function system_status_form($form, &$form_state) {

  $form['system_status_service'] = array(
    '#type' => 'textfield',
    '#title' => t('Your siteUUID'),
    '#description' => system_status_get_siteUUID(),
    '#default_value' => system_status_get_siteUUID(),
    '#attributes' => array('style' => array('display:none;')),
    '#size' => 60,
    '#maxlength' => 60,
    '#disabled' => TRUE,
  );

  $form['system_status_service_allow_external'] = array(
    '#type' => 'checkbox',
    '#title' => t('Allow external services to fetch this site'),
    '#description' => t('Allow reports to be generated by external services. <br>All information will be sent using encryption and is only accessible using your siteUUID.'),
    '#default_value' => TRUE,
    '#disabled' => TRUE,
  );

  $form['add_site'] = array(
    '#type' => 'submit',
    '#value' => t('Go to project page'),
    '#attributes' => array('style' => array('margin-top:30px;')),
    '#submit' => array('system_status_more_info'),
  );

  return system_settings_form($form);
}

function system_status_form_alter(&$form, &$form_state, $form_id) {
  if ($form_id == 'system_status_form') {
    unset($form['actions']['submit']);
  }
}

function system_status_get_siteUUID() {
  $siteUUID = variable_get('system_status_token', 'Error-no-token');
  $siteUUID .= "-";
  $siteUUID .= variable_get('system_status_encrypt_token', 'Error-no-token');

  return $siteUUID;
}

function system_status_more_info($form, &$form_state) {
  $url = "https://www.drupal.org/project/system_status/";

  if (module_exists('overlay') && overlay_get_mode() == 'child') {
    unset($_GET['destination']);
    overlay_close_dialog($url, array('external' => TRUE));
    $form_state['redirect'] = FALSE;
  } else {
    $form_state['redirect'] = $url;
  }
}
